<template>
  <div class="container">
    <div class="row">
      <div class="form-group col-md-4">
        <label class="control-label">
          ¿ Tiene efectivo en metales ?
        </label>
        <p-radio class="d-inline-block" v-model="bandera" label="1">Si</p-radio>
        <p-radio class="d-inline-block" v-model="bandera" label="0">No</p-radio>
      </div>
    </div>
    <div v-if="bandera == '1'">
      <div v-if="add_item">
        <div class="row">
          <legend>Efectivo y Metales </legend>
        </div>
        <div class="row">
          <div class="form-group col-md-4">
            <label class="control-label">Tipo de Operación</label>
            <el-select  clearable filterable class="select-default" placeholder="Seleccione una opción" v-model="item_metales.tipo_operacion_id">
              <el-option v-for="option in operaciones" class="select-default" :value="option.id" :label="option.valor" :key="option.label"></el-option>
            </el-select>
          </div>
          <div class="form-group col-md-4" v-if=" item_metales.tipo_operacion_id == 4">
            <label class="control-label">Especificar tipo operación</label>
            <input class="form-control" type="text" v-model="item_metales.tipo_operacion_especificar" placeholder="Especificar">
          </div>
          <div class="form-group col-md-4 customCurrency">
            <label class="control-label">Monto</label>
            <b-input-group size="sm" :prepend="getSigno">
              <b-form-input type="number" class="text-right" v-model="item_metales.monto_moneda" placeholder="0" @keyup.native="isNumber" />
              <b-dropdown right split :text="getCodigoMoneda" v-model="item_metales.moneda_id">
                <b-dropdown-item v-for="option in monedas" :key="option.codigo" :value="option.codigo" @click="item_metales.moneda_id = option.id">{{option.moneda}}</b-dropdown-item>
              </b-dropdown>
            </b-input-group>
          </div>
          <div class="form-group col-md-4">
            <label class="control-label">Tipo de Metal</label>
            <el-select  clearable filterable class="select-default" placeholder="Seleccione una opción" v-model="item_metales.tipo_metal_id">
              <el-option v-for="option in metales" class="select-default" :value="option.id" :label="option.valor" :key="option.label"></el-option>
            </el-select>
          </div>
          <div class="form-group col-md-4" v-if=" item_metales.tipo_metal_id == 4">
            <label class="control-label">Especificar tipo metal</label>
            <input class="form-control" type="text" v-model="item_metales.tipo_metal_especificar" placeholder="Especificar">
          </div>
          <div class="form-group col-md-4">
            <label class="control-label">Unidades</label>
            <input class="form-control" type="text" v-model="item_metales.unidades" placeholder="Unidades">
          </div>
          <div class="form-group col-md-4">
            <label class="control-label">Monto en pesos (si aplica)</label>
            <input class="form-control" type="text" v-model="item_metales.monto_metal" placeholder="Unidades">
          </div>
          <div class="form-group col-md-4">
            <label class="control-label">Forma de adquisición</label>
            <el-select  clearable filterable class="select-default" placeholder="Forma de adquisición" v-model="item_metales.forma_adquisicion_id">
              <el-option v-for="option in adquisiciones" class="select-default" :value="option.id" :label="option.valor" :key="option.label"></el-option>
            </el-select>
          </div>
          <div class="form-group col-md-4" v-if="item_metales.forma_adquisicion_id == 8">
            <label class="control-label">Especificar forma de adquisición</label>
            <input class="form-control" type="text" v-model="item_metales.forma_especificar" placeholder="Especificar">
          </div>
          <div class="form-group col">
            <label class="control-label">Observaciones / Comentarios</label>
            <input class="form-control" type="text" v-model="item_metales.observaciones" placeholder="Observaciones / Comentarios">
          </div>
        </div>
        <div class="row justify-content-end m-3">
          <button class="btn btn-primary" @click.prevent="addItem()">
            <span v-if="edit_item == null">
              <i class="fa fa-plus"></i> Agregar
            </span>
            <span v-else>
              <i class="fa fa-save"></i> Guardar
            </span>
          </button>
          <button class="btn btn-danger ml-3" @click.prevent="cancelEdit()">
            <span>
              <i class="fa fa-times"></i> Cancelar
            </span>
          </button>
        </div>
        <div class="row">
          <hr class="col-md-12 bg-info">
        </div>
      </div>
      <div v-if="!add_item">
        <div class="row justify-content-end m-3">
          <button class="btn btn-primary" @click.prevent="showItem()">
            <span>
              <i class="fa fa-plus"></i> Agregar
            </span>
          </button>
        </div>
        <div class="row mt-3 mb-4">
          <div class="col-sm-12 col-md-12 col-lg-12">
            <b-table id="tbl_metales" responsive hover :items="list_metales" :fields="fields_list" show-empty>
              <!-- :fields="fields_list" -->
              <template slot="acciones" slot-scope="row" class="actions">
                <b-button size="sm" @click.prevent="editItem(row)" class="edit mr-2" :disabled="edit_item != null">
                  Editar <i class="fas fa-pencil-alt ml-2"></i>
                </b-button>
                <b-button size="sm" @click.prevent="removeItem(row.index)" class="delete mr-2" :disabled="edit_item != null">
                  Eliminar <i class="fas fa-trash-alt ml-2"></i>
                </b-button>
              </template>
              <template slot="empty">
                <h5>No existen registros</h5>
              </template>
              <template slot="forma_adquisicion_id" slot-scope="row">{{getFormaAdquisicion(row.item.forma_adquisicion_id)}}</template>
              <template slot="monto_moneda" slot-scope="row" class="text-right">{{(getSignoDos(row.item.moneda_id))}}
                {{row.item.monto_moneda | currency}}</template>
              <template slot="monto_metal" slot-scope="row" class="text-right">{{(getSignoDos(row.item.moneda_id))}}
                {{row.item.monto_metal | currency}}</template>
              <template slot="moneda_id" slot-scope="row" class="text-center">
                {{getMoneda(row.item.moneda_id)}}</template>
              <template slot="tipo_metal_id" slot-scope="row">{{getTipo(row.item.tipo_metal_id)}}</template>
              <template slot="tipo_operacion_id" slot-scope="row">{{getOperacion(row.item.tipo_operacion_id)}}</template>
            </b-table>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
  import {
    Tag,
    Select,
    DatePicker,
    InputNumber
  } from "element-ui";
  import {
    mapFields
  } from "vee-validate";
  export default {
    components: {
      [Tag.name]: Tag,
      [DatePicker.name]: DatePicker,
      [InputNumber.name]: InputNumber
    },
    props: ["data"],
    data() {
      return {
        ip_id: 1,
        add_item: false,
        edit_item: null,
        bandera: '0',
        modelValidations: {
          nombre: {
            min: 5
          },
          email: {
            required: true,
            email: true
          }
        },
        operaciones: null,
        adquisiciones: null,
        monedas: [],
        metales: [],
        isnum: null,
        /* Lista de metales */
        item_metales: {},
        list_metales: [],
        fields_list: [{
            key: "acciones",
            label: "Acciones",
            tdClass: "text-center"
          },
          {
            key: "tipo_operacion_id",
            label: "Tipo Operacion",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "tipo_operacion_especificar",
            label: "Especificar",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "tipo_metal_id",
            label: "Tipo de metal",
            tdClass: "text-left",
            formatter: 'emptyFields'
          }, ,
          {
            key: "tipo_metal_especificar",
            label: "Especificar",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "unidades",
            label: "Unidades",
            tdClass: "text-right",
            formatter: 'emptyFields'
          },
          {
            key: "monto_moneda",
            label: "Monto Original",
            tdClass: "text-right",
            formatter: 'emptyFields'
          },
          {
            key: "moneda_id",
            label: "Moneda",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "monto_metal",
            label: "Monto en pesos",
            tdClass: "text-right",
            formatter: 'emptyFields'
          },
          {
            key: "forma_adquisicion_id",
            label: "Forma de adquisicion",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "forma_especificar",
            label: "Especificar",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
          {
            key: "observaciones",
            label: "Observaciones",
            tdClass: "text-left",
            formatter: 'emptyFields'
          },
        ]
      };
    },
    computed: {
      getSigno() {
        var signo = "$";
        var val = this.item_metales.moneda_id;
        this.monedas.forEach(function (item) {
          if (item.id == val) {
            signo = item.signo;
          }
        });
        return signo;
      },
      getCodigoMoneda() {
        var codigo = "MXN";
        var val = this.item_metales.moneda_id;
        this.monedas.forEach(function (item) {
          if (item.id == val) {
            codigo = item.codigo;
          }
        });
        return codigo;
      },
    },
    watch: {
      list_metales: {
        handler: function () {
          if (this.list_metales) {
            if (this.list_metales.length == 0) {
              this.bandera = '0';
            } else {
              this.bandera = '1';
            }
          }
        },
        deep: true
      },
    },
    methods: {
      getSignoDos(val = "97") {
        var signo = "$";
        this.monedas.forEach(function (item) {
          if (item.id == val) {
            signo = item.signo;
          }
        });
        return signo;
      },
      emptyFields(value) {
        if (value) {
          if (typeof value === 'string' || value instanceof String) {
            return value.toUpperCase();
          } else {
            return value;
          }
        } else {
          return '-';
        }
      },
      getOperacion(index) {
        var resp = " ";
        if (this.operaciones) {
          this.operaciones.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      getTipo(index) {
        var resp = " ";
        if (this.metales) {
          this.metales.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      getMoneda(index) {
        var resp = "";
        if (this.monedas) {
          this.monedas.forEach(function (item) {
            if (item.id == index) {
              resp = item.moneda;
            }
          });
        }
        return resp;
      },
      getFormaAdquisicion(index) {
        var resp = " ";
        if (this.adquisiciones) {
          this.adquisiciones.forEach(function (item) {
            if (item.id == index) {
              resp = item.valor;
              return resp;
            }
          });
        }
        return resp;
      },
      initItem() {
        this.item_metales = {
          acciones: "",
          tipo_operacion_id: "",
          tipo_operacion_especificar: "",
          tipo_metal_id: "",
          tipo_metal_especificar: "",
          unidades: "",
          monto_moneda: "",
          moneda_id: 97,
          monto_metal: "",
          forma_adquisicion_id: "",
          forma_especificar: "",
          observaciones: "",
        };
      },
      showItem() {
        this.add_item = !this.add_item;
      },
      cancelEdit() {
        if (this.edit_item) {
          this.edit_item.item._rowVariant = "";
        }
        this.initItem();
        this.showItem();
        this.edit_item = null;
      },
      addItem() {
        if (this.item_metales) {
          this.item_metales.ip_id = this.ip_id;
          this.loadButton(this.$refs.btnSave);
          this.$http.post("efectivo_metales", this.item_metales).then(
            response => {
              this.StepOk("Guardado");
              if (this.edit_item === undefined || this.edit_item === null) {
                this.list_metales.push({
                  ...response.data.efectivo
                });
              } else {
                this.list_metales.splice(
                  this.edit_item.index,
                  1,
                  this.item_metales
                );
                this.edit_item.item._rowVariant = "";
              }
              this.initItem();
              this.showItem();
              this.edit_item = null;
            },
            error => {
              this.StepError(error);
              //this.change =  true;
            }
          );
        } else {
          this.StepW("Hay campos sin completar");
        }
        //console.log(this.item_metales);
      },
      editItem(indice) {
        this.showItem();
        this.edit_item = indice;
        this.item_metales = {
          ...this.list_metales[this.edit_item.index]
        };
        this.edit_item.item._rowVariant = "danger";
        $(".main-panel").animate({
            scrollTop: 100
          },
          500,
          "swing"
        );
      },
      removeItem(indice) {
        if (this.list_metales[indice].id !== null) {
          let item = this.list_metales[indice];
          this.Ask("Desea borrar este registro", () => {
            this.$http.delete("efectivo_metales/" + item.id).then(
              response => {
                /* eventBus.$emit("TramiteDelete", item); */
                this.list_metales.splice(indice, 1);
              },
              error => {
                this.Err(error);
              }
            );
          });
        }
      },
      getError(fieldName) {
        return this.errors.first(fieldName);
      },
      validate() {
        return this.$validator.validateAll();
      },
      isNumber(n) {
        //console.log(n);
        n.target.value = n.target.value.replace(/[^\d.-]/g, '');
      }
    },
    created() {
      this.initItem();
      //this.getLocalidades(97250);
      this.$http.get("efectivo_metales/" + this.ip_id).then(
        response => {
          this.list_metales = response.data.efectivos;
        },
        error => {
          this.Err(error);
        }
      );
      this.$http.get("cat_tipo_operacion_inversion").then(
        response => {
          this.operaciones = response.data.tipos;
        },
        error => {
          this.Err(error);
        }
      );
      this.$http.get("cat_forma_adquisicion").then(
        response => {
          this.adquisiciones = response.data.adquisiciones;
        },
        error => {
          this.Err(error);
        }
      );
      this.$http.get("cat_tipo_metal").then(
        response => {
          this.metales = response.data.tipos;
        },
        error => {
          this.Err(error);
        }
      );
      this.$http.get("monedas").then(
        response => {
          this.monedas = response.data.monedas;
          /* var temp = "97";
          this.monedas.forEach(function (item) {
            if (item.codigo == "MXN") {
              temp = item.id;
            }
          });
          this.item_metales.moneda_id = temp; */
        },
        error => {
          this.Err(error);
        }
      );
      if (this.data) {}
    }
  };

</script>
<style>


</style>
